<?php
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");
require_once("../../classes/class.date_processing.php");
require_once("../../classes/class.ui_helpers.php");

require_once("../../classes/school_administration/class.classes.php");
require_once('../../classes/school_administration/class.class_sections.php');

require_once("../../classes/academic_supervision/class.chapters.php");
require_once("../../classes/academic_supervision/class.chapter_topics.php");
require_once("../../classes/academic_supervision/class.student_assignment.php");

require_once("../../includes/global_defaults.inc.php");
//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_LIST_STUDENT_ASSIGNMENT) !== true)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}

$HasErrors = false;

$Clean = array();
$Clean['Process'] = 0;

$Clean['AssignmentID'] = 0;

/*if (isset($_GET['Process']))
{
    $Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
    case 5:
        if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT_ASSIGNMENT) !== true)
        {
            header('location:unauthorized_login_admin.php');
            exit;
        }
        
        if (isset($_GET['DepartmentID']))
        {
            $Clean['DepartmentID'] = (int) $_GET['DepartmentID'];           
        }
        
        if ($Clean['DepartmentID'] <= 0)
        {
            header('location:../error.php');
            exit;
        }                       
            
        try
        {
            $DepartmentToDelete = new Department($Clean['DepartmentID']);
        }
        catch (ApplicationDBException $e)
        {
            header('location:../error.php');
            exit;
        }
        catch (Exception $e)
        {
            header('location:../error.php');
            exit;
        }
        
        $RecordValidator = new Validator();
        
        // if ($DepartmentToDelete->CheckDependencies())
        // {
        //  $RecordValidator->AttachTextError('This master product unit cannot be deleted. There are dependent records for this master product unit.');
        //  $HasErrors = true;
        //  break;
        // }
                
        if (!$DepartmentToDelete->Remove())
        {
            $RecordValidator->AttachTextError(ProcessErrors($DepartmentToDelete->GetLastErrorCode()));
            $HasErrors = true;
            break;
        }
        
        $RecordDeletedSuccessfully = true;
        break;
}*/

if (isset($_GET['AssignmentID']))
{
    $Clean['AssignmentID'] = (int) $_GET['AssignmentID'];
}

$AssignmentAnswers = array();
$AssignmentAnswers = StudentAssignment::GetAssignmentAnswers($Clean['AssignmentID']);

/*try
{
    $StudentAssignmentObj = new StudentAssignment($Clean['AssignmentID']);
    $ClassSectionsObj = new ClassSections($StudentAssignmentObj->GetClassSectionID());
    $AddedClassObj = new AddedClass($ClassSectionsObj->GetClassID());
}
catch (Exception $e)
{
    header('location:unauthorized_login_admin.php');
    exit;
}*/

require_once('../html_header.php');
?>
<title>Students Assignment Answers List</title>
<!-- DataTables CSS -->
<link href="/admin/vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="/admin/vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../site_header.php');
            require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Students Assignment Answers List</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo count($AssignmentAnswers); ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
<?php
                            if ($HasErrors == true)
                            {
                                echo $RecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTableHeading">
                                    <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Students Assignment Answers List on <?php echo date('d-m-Y h:i A'); ?></strong></div>
                                    </div>
                                </div>
                                
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" style="display: none;" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr role="row">
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 118px;">Class</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 82px;">Subject</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 53px;">Chapter</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 37px;">Topic</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 177px;">Heading</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 41px;">Issue Date</th>
                                                    <th class="sorting_disabled" rowspan="1" colspan="1" style="width: 34px;">End Date</th>
                                                </tr>
                                            </thead>
                                        </table>
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>Roll Number</th>
                                                    <th>Student Name</th>
                                                    <th>Create Date</th>
                                                    <th class="print-hidden">View Answer</th>
                                                </tr>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($AssignmentAnswers) && count($AssignmentAnswers) > 0)
                                    {
                                        //echo '<pre>';
                                        //print_r($AssignmentAnswers);exit;
                                        $Counter = 0;
                                        foreach ($AssignmentAnswers as $AssignmentAnswersID => $AssignmentAnswersDetails)
                                        {
?>
                                        <tr>
                                            <td><?php echo $AssignmentAnswersDetails['RollNumber']; ?></td>
                                            <td><?php echo $AssignmentAnswersDetails['StudentName']; ?></td>
<?php
                                            if ($AssignmentAnswersDetails['CreateDate'] != '' && $AssignmentAnswersDetails['AnswerImageName'] != '')
                                            {
?>
                                                <td><?php echo date('d/m/Y h:i:A', strtotime($AssignmentAnswersDetails['CreateDate'])); ?></td>
                                                <td class="print-hidden">
<?php
                                                if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT_ASSIGNMENT) === true)
                                                {
                                                    //echo '<a target="_blank" href="/site_images/student_assignment_answers/' . $AssignmentAnswersDetails['AssignmentID'] . '/' . $AssignmentAnswersDetails['AnswerImageName'] .'"><i class="fa fa-eye" area-hidden="true"></i></a>';
                                                    echo '<a target="_blank" href="student_assignment_answers_list.php?StudentID='.$AssignmentAnswersDetails['StudentID'].'&AssignmentID='.$AssignmentAnswersDetails['AssignmentID'].'"><i class="fa fa-eye" area-hidden="true"></i></a>';
                                                }
?>
                                                </td>
<?php
                                            }
                                            else
                                            {
?>
                                                <td>NA</td>
                                                <td class="print-hidden">NA</td>
<?php
                                            }
?>
                                            
                                        </tr>
<?php
                                        }
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
if (PrintMessage($_GET, $Message))
{
?>
<script type="text/javascript">
    alert('<?php echo $Message; ?>');
</script>
<?php
}
?>
<!-- DataTables JavaScript -->
<script src="/admin/vendor/datatables/js/jquery.dataTables.min.js"></script>
<script src="/admin/vendor/datatables-plugins/dataTables.bootstrap.min.js"></script>
<script src="/admin/vendor/datatables-responsive/dataTables.responsive.js"></script>    
<script type="text/javascript">
$(document).ready(function() {
    $("body").on('click', '.delete-record', function()
    {   
        if (!confirm("Are you sure you want to delete this department?"))
        {
            return false;
        }
    });

    $('#DataTableRecords').DataTable({
        responsive: true,
        bPaginate: true,
        bSort: true,
        searching: true, 
        info: true
    });
});
</script>
<!-- JavaScript To Print A Report -->
<script src="/admin/js/print-report.js"></script>
</body>
</html>