<?php
// error_reporting(E_ALL);
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once("../../classes/admission_cell/class.enquiries.php");
require_once("../../classes/admission_cell/class.student_registrations.php");

require_once("../../classes/school_administration/class.academic_years.php");
require_once("../../classes/school_administration/class.students.php");
require_once("../../classes/school_administration/class.parent_details.php");
require_once("../../classes/school_administration/class.student_details.php");

require_once("../../classes/school_administration/class.colour_houses.php");
require_once("../../classes/school_administration/class.classes.php");
require_once("../../classes/school_administration/class.section_master.php");
require_once("../../classes/school_administration/class.class_sections.php");
require_once("../../classes/school_administration/class.countries.php");
require_once("../../classes/school_administration/class.states.php");
require_once("../../classes/school_administration/class.cities.php");

require_once("../../classes/fee_management/class.fee_groups.php");

require_once("../../classes/class.date_processing.php");
require_once("../../classes/class.helpers.php");

require_once("../../includes/helpers.inc.php");
require_once("../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_ADD_STUDENT) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$SchoolName = 'Demo Public School';
$AffilationDetails = 'RECOGNIZED (ENGLISH MEDIUM)';
$OtherDetails = 'Run Under Christian Community Educational Society, Lucknow';
$Address = 'FF-10, Janki-Plaza, JankiPuram, Lucknow, UP';
$Pincode = 261001;
$City = 'Lucknow';
$State = 'UP';
$ContactNumber = '0522-211111, 9111111111';
$AffilationNumber = '';

$HasErrors = false;

$AcademicYears =  array();
$AcademicYears = AcademicYear::GetAllAcademicYears();

$ActiveFeeGroups = array();
$ActiveFeeGroups = FeeGroup::GetActiveFeeGroups();

$StudentTypeList = array('New' => 'New', 'Old' => 'Old');
$GenderList = array('Male' => 'Male', 'Female' => 'Female', 'Others' => 'Others');
$BloodGroupList = array('A+' => 'A+', 'A-' => 'A-', 'B+' => 'B+', 'AB+' => 'AB+', 'AB-' => 'AB-', 'O+' => 'O+', 'O-' => 'O-');
$ReligionList = array('Hindu' => 'Hindu', 'Muslim' => 'Muslim', 'Sikh' => 'Sikh', 'Christian' => 'Christian', 'Others' => 'Others', 'Not Specified' => 'Not Specified');
$CategoryList = array('General' => 'General', 'OBC' => 'OBC', 'SC' => 'SC', 'ST' => 'ST');
$OtherCategoryList = array('IsEWS' => 'EWS', 'HasDisability' => 'Disabled', 'IsSingleGirl' => 'Single Girl');
$LastSchoolBoardList = array('CBSE' => 'CBSE', 'ICSE' => 'ICSE', 'UP' => 'UP');
$TCReceivedList = array(1 => 'Yes', 0 => 'No');
$LastExamStatusList = array('Passed' => 'Passed', 'Failed' => 'Failed', 'Awaited' => 'Awaited');
$MotherTongueList = array('Hindi' => 'Hindi', 'English' => 'English');

$ColorHouseList = array();
$ColorHouseList = ColourHouse::GetActiveColourHouses();

$ClassList =  array();
$ClassList = AddedClass::GetActiveClasses();

$AllSectionMasters = array();
$AllSectionMasters = SectionMaster::GetActiveSectionMasters();

$ClassSectionsList =  array();

$CountryList =  array();
$CountryList = Country::GetAllCountries();

$StateList =  array();
$DistrictList =  array();
$CityList =  array();

$ResidentailStateList =  array();
$ResidentailDistrictList =  array();
$ResidentailCityList =  array();

$PermanentStateList =  array();
$PermanentDistrictList =  array();
$PermanentCityList =  array();

$acceptable_extensions = array('jpeg', 'jpg', 'png', 'gif');
$acceptable_mime_types = array(
    'image/jpeg',
    'image/jpg', 
    'image/png', 
    'image/gif' 
);

$Clean = array();
$Clean['UploadFile'] = array();

$Clean['Process'] = 0;

$Clean['StudentID'] = 0;
$Clean['AcademicYearID'] = 0;
$Clean['RollNumber'] = 0;
$Clean['EnrollmentID'] = '';
$Clean['StudentType'] = 'New';
$Clean['ColourHouseID'] = 0;
$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;

$Clean['FirstName'] = '';
$Clean['LastName'] = '';
$Clean['DOB'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['Gender'] = 'Male';
$Clean['BloodGroup'] = '';
$Clean['Religion'] = '';
$Clean['Category'] = 'General';

$Clean['IsEWS'] = 0;
$Clean['HasDisability'] = 0;
$Clean['IsSingleGirl'] = 0;

$Clean['CountryID'] = key($CountryList);
$StateList = State::GetAllStates($Clean['CountryID']);

$Clean['StateID'] = key($StateList);

$DistrictList = City::GetAllDistricts($Clean['StateID']);
$Clean['DistrictID'] = key($DistrictList);

$CityList = City::GetAllCities($Clean['StateID'], $Clean['DistrictID']);
$Clean['CityID'] = key($CityList);

$Clean['PinCode'] = '';
$Clean['AadharNumber'] = 0;

$Clean['AdmissionDate'] = date('d/m/Y');
$Clean['MobileNumber'] = '';
$Clean['Email'] = '';
$Clean['Status'] = 'Active';

// Last Academic Details
$Clean['LastClass'] = '';
$Clean['LastSchool'] = '';
$Clean['LastSchoolBoard'] = 'CBSE';
$Clean['TCReceived'] = 0;
$Clean['TCDate'] = '';

$Clean['SubjectsProposed'] = '';
$Clean['MotherTongue'] = '';
$Clean['HomeTown'] = '';

$Clean['LastExamStatus'] = 'Passed';
$Clean['LastExamPercentage'] = 0;

// Parent Details
$Clean['ParentType'] = 'New';

$Clean['FeeGroupID'] = 0;
$Clean['FeeCode'] = '';
$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$Clean['FatherOccupation'] = '';
$Clean['MotherOccupation'] = '';

$Clean['FatherOfficeName'] = '';
$Clean['MotherOfficeName'] = '';
$Clean['FatherOfficeAddress'] = '';
$Clean['MotherOfficeAddress'] = '';

$Clean['ResidentailAddress'] = '';
$Clean['ResidentailCountryID'] = key($CountryList);

$ResidentailStateList = State::GetAllStates($Clean['ResidentailCountryID']);
$Clean['ResidentailStateID'] = key($ResidentailStateList);

$ResidentailDistrictList = City::GetAllDistricts($Clean['ResidentailStateID']);
$Clean['ResidentailDistrictID'] = key($ResidentailDistrictList);

$ResidentailCityList = City::GetAllCities($Clean['ResidentailStateID'], $Clean['ResidentailDistrictID']);
$Clean['ResidentailCityID'] = key($ResidentailCityList);

$Clean['ResidentailPinCode'] = '';

$Clean['PermanentAddress'] = '';
$Clean['PermanentCountryID'] = key($CountryList);

$PermanentStateList = State::GetAllStates($Clean['PermanentCountryID']);
$Clean['PermanentStateID'] = key($PermanentStateList);

$PermanentDistrictList = City::GetAllDistricts($Clean['PermanentStateID']);
$Clean['PermanentDistrictID'] = key($PermanentDistrictList);

$PermanentCityList = City::GetAllCities($Clean['PermanentStateID'], $Clean['PermanentDistrictID']);
$Clean['PermanentCityID'] = key($PermanentCityList);

$Clean['PermanentPinCode'] = '';

$Clean['PhoneNumber'] = '';
$Clean['ParentAadharNumber'] = 0;
$Clean['FatherMobileNumber'] = '';
$Clean['MotherMobileNumber'] = '';
$Clean['FatherEmail'] = '';
$Clean['MotherEmail'] = '';

$Clean['ParentID'] = 0;
$Clean['RegistrationFee'] = 0;
$Clean['StudentPhoto'] = '';

if (isset($_POST['hdnProcess']))
{
	$Clean['Process'] = (int) $_POST['hdnProcess'];
}
else if (isset($_GET['Process']))
{
    $Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
	case 2:
        if (isset($_GET['StudentID']))
        {
            $Clean['StudentID'] = (int) $_GET['StudentID'];
        }  

        if ($Clean['StudentID'] <= 0)
        {
            header('location:../error.php');
            exit;
        }

        try
        {
            $StudentDetails = new StudentDetail($Clean['StudentID']);
        }
        catch (ApplicationDBException $e)
        {
            header('location:../error.php');
            exit;
        }
        catch (Exception $e)
        {
            header('location:../error.php');
            exit;
        }

        $Clean['ParentID'] = $StudentDetails->GetParentID();
        $Clean['RollNumber'] = $StudentDetails->GetRollNumber();
        $Clean['EnrollmentID'] = $StudentDetails->GetEnrollmentID();
        $Clean['StudentType'] = $StudentDetails->GetStudentType();
        $Clean['Status'] = $StudentDetails->GetStatus();
        $Clean['ColourHouseID'] = $StudentDetails->GetColourHouseID();
        $Clean['ClassSectionID'] = $StudentDetails->GetClassSectionID();

        $ClassSectionDetails = new ClassSections($StudentDetails->GetClassSectionID());
        
        $Clean['ClassID'] = $ClassSectionDetails->GetClassID();
        $ClassSectionsList = ClassSections::GetClassSections($Clean['ClassID']);

        $Clean['FirstName'] = $StudentDetails->GetFirstName();
        $Clean['LastName'] = $StudentDetails->GetLastName();

        if ($StudentDetails->GetDOB() != '0000-00-00') 
        {
            $Clean['DOB'] = date('d/m/Y', strtotime($StudentDetails->GetDOB()));
        }
        
        $Clean['Gender'] = $StudentDetails->GetGender();        
        $Clean['BloodGroup'] = $StudentDetails->GetBloodGroup();
        $Clean['Religion'] = $StudentDetails->GetReligion();
        $Clean['Category'] = $StudentDetails->GetCategory();

        $Clean['IsEWS'] = $StudentDetails->GetIsEWS();
        $Clean['HasDisability'] = $StudentDetails->GetHasDisability();
        $Clean['IsSingleGirl'] = $StudentDetails->GetIsSingleGirl();

        $Clean['Address1'] = $StudentDetails->GetAddress1();
        $Clean['Address2'] = $StudentDetails->GetAddress2();
        
        $Clean['CountryID'] = $StudentDetails->GetCountryID();
        
        $StateList = State::GetAllStates($Clean['CountryID']);
        $Clean['StateID'] = $StudentDetails->GetStateID();
        
        $DistrictList = City::GetAllDistricts($Clean['StateID']);
        $Clean['DistrictID'] = $StudentDetails->GetDistrictID();
        
        $CityList = City::GetAllCities($Clean['StateID'], $Clean['DistrictID']);
        $Clean['CityID'] = $StudentDetails->GetCityID();
        
        $Clean['Pincode'] = $StudentDetails->GetPincode();

        if ($StudentDetails->GetAdmissionDate() != '0000-00-00') 
        {
            $Clean['AdmissionDate'] = date('d/m/Y', strtotime($StudentDetails->GetAdmissionDate()));
        }
        
        $Clean['MobileNumber'] = $StudentDetails->GetMobileNumber();
        $Clean['Email'] = $StudentDetails->GetEmail();
        $Clean['AadharNumber'] = $StudentDetails->GetAadharNumber();

        $Clean['LastClass'] = $StudentDetails->GetLastClass();
        $Clean['LastSchool'] = $StudentDetails->GetLastSchool();
        $Clean['LastSchoolBoard'] = $StudentDetails->GetLastSchoolBoard();
        $Clean['TCReceived'] = $StudentDetails->GetTCReceived();

        if ($StudentDetails->GetTCDate() != '0000-00-00') 
        {
            $Clean['TCDate'] = date('d/m/Y', strtotime($StudentDetails->GetTCDate()));
        }

        $Clean['SubjectsProposed'] = $StudentDetails->GetSubjectsProposed();
        $Clean['MotherTongue'] = $StudentDetails->GetMotherTongue();
        $Clean['HomeTown'] = $StudentDetails->GetHomeTown();

        $Clean['LastExamStatus'] = $StudentDetails->GetLastExamStatus();
        $Clean['LastExamPercentage'] = $StudentDetails->GetLastExamPercentage();
       
        $ParentDetails = new ParentDetail($StudentDetails->GetParentID());

        $Clean['FatherFirstName'] = $ParentDetails->GetFatherFirstName();
        $Clean['FeeCode'] = $ParentDetails->GetFeeCode();
        $Clean['FatherLastName'] = $ParentDetails->GetFatherLastName();
        $Clean['MotherFirstName'] = $ParentDetails->GetMotherFirstName();
        $Clean['MotherLastName'] = $ParentDetails->GetMotherLastName();

        $Clean['FatherOccupation'] = $ParentDetails->GetFatherOccupation();
        $Clean['MotherOccupation'] = $ParentDetails->GetMotherOccupation();
        $Clean['FatherOfficeName'] = $ParentDetails->GetFatherOfficeName();
        $Clean['MotherOfficeName'] = $ParentDetails->GetMotherOfficeName();
        $Clean['FatherOfficeAddress'] = $ParentDetails->GetFatherOfficeAddress();
        $Clean['MotherOfficeAddress'] = $ParentDetails->GetMotherOfficeAddress();

        $Clean['ResidentailAddress'] = $ParentDetails->GetResidentailAddress();
        $Clean['ResidentailCityID'] = $ParentDetails->GetResidentailCityID();
        $Clean['ResidentailDistrictID'] = $ParentDetails->GetResidentailDistrictID();
        $Clean['ResidentailStateID'] = $ParentDetails->GetResidentailStateID();
        $Clean['ResidentailCountryID'] = $ParentDetails->GetResidentailCountryID();
        $Clean['ResidentailPinCode'] = $ParentDetails->GetResidentailPinCode();
        
        $ResidentailStateList = State::GetAllStates($Clean['ResidentailCountryID']);
        $ResidentailDistrictList = City::GetAllDistricts($Clean['ResidentailStateID']);
        $ResidentailCityList = City::GetAllCities($Clean['ResidentailStateID'], $Clean['ResidentailDistrictID']);

        $Clean['PermanentAddress'] = $ParentDetails->GetPermanentAddress();
        $Clean['PermanentCityID'] = $ParentDetails->GetPermanentCityID();
        $Clean['PermanentDistrictID'] = $ParentDetails->GetPermanentDistrictID();
        $Clean['PermanentStateID'] = $ParentDetails->GetPermanentStateID();
        $Clean['PermanentCountryID'] = $ParentDetails->GetPermanentCountryID();
        $Clean['PermanentPinCode'] = $ParentDetails->GetPermanentPinCode();
        
        $PermanentStateList = State::GetAllStates($Clean['PermanentCountryID']);
        $PermanentDistrictList = City::GetAllDistricts($Clean['PermanentStateID']);
        $PermanentCityList = City::GetAllCities($Clean['PermanentStateID'], $Clean['PermanentDistrictID']);

        $Clean['PhoneNumber'] = $ParentDetails->GetPhoneNumber();
        $Clean['FatherMobileNumber'] = $ParentDetails->GetFatherMobileNumber();
        $Clean['MotherMobileNumber'] = $ParentDetails->GetMotherMobileNumber();

        $Clean['FatherEmail'] = $ParentDetails->GetFatherEmail();
        $Clean['MotherEmail'] = $ParentDetails->GetMotherEmail();

        $Clean['ParentAadharNumber'] = $ParentDetails->GetAadharNumber();

        $Clean['AcademicYearID'] = $StudentDetails->GetAcademicYearID();
        
        $Clean['StudentPhoto'] = $StudentDetails->GetStudentPhoto();

        $StudentRegistrationOgj = new StudentRegistration($StudentDetails->GetStudentRegistrationID());

        $Clean['RegistrationFee'] = $StudentRegistrationOgj->GetRegistrationFee();

        $StudentPhoto = '/images/profile-dummy.png';
        
        if (file_exists(SITE_FS_PATH . '/site_images/student_images/' . $StudentDetails->GetStudentID() . '/' . $StudentDetails->GetStudentPhoto()))
        {
            $StudentPhoto = '/site_images/student_images/' . $StudentDetails->GetStudentID() . '/' . $StudentDetails->GetStudentPhoto();
        }
        
        break;
}

require_once('../html_header.php');
?>
<title>Print Admission Form</title>
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
            <link rel='stylesheet' href='https://use.fontawesome.com/releases/v5.7.0/css/all.css' integrity='sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ' crossorigin='anonymous'>
<?php 
			require_once('../site_header.php');
			require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Print Admission Form</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            	<div class="panel panel-default">
                    <div class="panel-heading">
                        <strong>Print Admission Form</strong>
                    </div>
                    <div class="panel-body">
                    <div>
                        <div class="row" id="RecordTableHeading" style="page-break-before: always;">
                            <div class="align-center" style="position: relative; width:600px; height:80px;display:block;">
                                <div style="height:80px; width:300px;margin-top:20px; text-align:center;">
                                    <a style = "font-size:20px;" href="<?php echo SITE_HTTP_PATH . '/site_images/print_admission_form.pdf';?>" target="_blank">
                                        Print Admission Form &nbsp;&nbsp;&nbsp;<span class="fas fa-download"></span>
                                    </a>

                                </div>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->
    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
if (PrintMessage($_GET, $Message))
{
?>
    <script type="text/javascript">
        alert('<?php echo $Message; ?>');
    </script>
<?php
}
?>
<script src="../vendor/jquery-ui/jquery-ui.min.js"></script>
<link href="../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">

<script src="../js/print-report.js"></script>

</body>
</html>