<?php
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once('../../classes/school_administration/class.students.php');
require_once('../../classes/school_administration/class.student_details.php');
require_once("../../classes/school_administration/class.parent_details.php");
require_once("../../classes/school_administration/class.classes.php");
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.academic_years.php');
require_once("../../classes/school_administration/class.section_master.php");

require_once("../../classes/school_administration/class.grades.php");

require_once("../../classes/examination/class.exam_types.php");
require_once("../../classes/examination/class.exams.php");

require_once("../../classes/examination/class.student_exam_mark.php");

require_once("../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try {
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
} catch (Exception $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

$AcademicYear = '';
AcademicYear::GetCurrentAcademicYear($AcademicYear);

$AllGrades = array();
$AllGrades = Grade::GetAllGrades();
$HasErrors = false;

$Clean = array();

$Clean['SelectedStudents'] = 1;
$Clean['SelectedExamType'] = '';

$MininumMarks = 20;

if (isset($_GET['SelectedStudents'])) {
    $Clean['SelectedStudents'] = (string) $_GET['SelectedStudents'];
}

if ($Clean['SelectedStudents'] == '') {
    header('location:admin/error.php');
    exit;
}

if (isset($_GET['SelectedExamType'])) {
    $Clean['SelectedExamType'] = (string) $_GET['SelectedExamType'];
}

if ($Clean['SelectedExamType'] == '') {
    header('location:admin/error.php');
    exit;
}

$Clean['SelectedStudentList'] = explode('$', $Clean['SelectedStudents']);
$Clean['SelectedExamTypeList'] = explode(',', $Clean['SelectedExamType']);

require_once('../html_header.php');
?>
<title>Print Report Card</title>
<!-- DataTables CSS -->
<link href="../vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="../vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>
<body>
    <div id="wrapper">
            <div class="row">
                <div class="col-lg-12 col-md-12 col-12 col-sm-12 col-xs-12">
                    <div class="panel panel-default">
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                                <div class="row">
                                    <div class="col-lg-12 col-md-12 col-12 col-sm-12 col-xs-12" style="text-align: right;">
                                    <div class="print-btn-container" style="margin-right:6px; margin-top:6px;"><button id="PrintButton" type="submit" class="btn btn-primary hidden-print" onclick="myFunction()">Print All</button>
                                    </div>
                                </div>
                                <div class="row" id="RecordTable" style="page-break-before: always;">
                                    <div class="col-lg-12">
                                        <?php

                                        foreach ($Clean['SelectedStudentList'] as $key => $StudentID) {
                                        try {
                                            $CurrentStudent = new StudentDetail($StudentID);
                                            $CurrentParent = new ParentDetail($CurrentStudent->GetParentID());
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }

                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                            try {
                                                $ExamTypeToEdit = new ExamType($ExamTypeID);
                                            } catch (ApplicationDBException $e) {
                                                header('location:/admin/error.php');
                                                exit;
                                            } catch (Exception $e) {
                                                header('location:/admin/error.php');
                                                exit;
                                            }
                                        }

                                        $AllHappendedExamList = array();
                                        $AllHappendedExamList = Exam::GetAllExamsForReportCard($CurrentStudent->GetClassSectionID(), false, $Clean['SelectedExamType']);

                                        // echo '<pre>';
                                        // var_dump($AllHappendedExamList);exit;
                                        $NextClassName = '';
                                        $ClassNameForFormate = '';
                                        try {
                                            $CurrentClassSections = new ClassSections($CurrentStudent->GetClassSectionID());
                                            $CurrentClass = new AddedClass($CurrentClassSections->GetClassID());
                                            
                                            if($CurrentClassSections->GetClassID() != 15){
                                            $NextClass = new AddedClass($CurrentClassSections->GetClassID() + 1);
                                            $ClassNameForFormate = $CurrentClass->GetClassName();
                                            $NextClassName = 'CLASS '.$NextClass->GetClassName();
                                            }
                                            
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }

                                        $CurrentClass->FillAssignedSubjects($CurrentStudent->GetClassSectionID());

                                        $AllClassSubjects = array();
                                        $AllClassSubjects = $CurrentClass->GetAssignedSubjects();

                                        try {
                                            $CurrentSectionMaster = new SectionMaster($CurrentClassSections->GetSectionMasterID());
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }
                                        ?>
                                        <div style="border:2px solid black;" id="border">
                                        
                                            <div class="row">
                                                <div class="col-lg-9 col-md-9 col-9 col-sm-9 col-xs-9"></div>
                                                <div class="col-lg-3 col-md-3 col-3 col-sm-3 col-xs-3" id="right_head"><span>&nbsp;Affiliation Code:2131190</span></div>
                                            </div>    
                                            <div class="row">
                                                <div class="col-lg-3 col-md-3 col-3 col-sm-3 col-xs-3" id="left_head"><img src="../../site_images/school_logo/school_logo.png" id="logo" style="float:left;width:100px;height:100px"></div>
                                                <div class="col-lg-6 col-md-6 col-6 col-sm-6 col-xs-6">
                                                    
                                                    <div style="float:left; text-align:center;">
                                                        <span style="font-weight: bold;font-size: 20px; white-space: nowrap" id="schoolName">PRITHVIRAJ CHAUHAN EDUCATION CENTRE</span><br>
                                                        
                                                        <span style="font-weight: bold;font-size: 12px;">&nbsp;BHAUTI, PRATAPPUR, KANPUR NAGAR, Kanpur Nagar - 209305</span><br>
                                                        <span style="font-weight: bold;font-size: 12px;"> Phone : 7897542696, e-mail : prithviraj.edu@gmail.com</span><br>
                                                        <span style="font-weight: bold;font-size: 12px;"> Web : www.prithvirajchauhaneducationcentre.com</span><br>
                                                        <span style="font-weight: bold;font-size: 13px;">REPORT CARD FOR SESSION : &nbsp;<?php echo $AcademicYear; ?></span></center>
                                                    </div>
                                                    <!-- <img src="../../site_images/school_logo/cbse-logo.png" height="65px;" width="100px;" style="margin-top: 10px;"> -->
                                                </div>
                                                <div class="col-lg-3 col-md-3 col-3 col-sm-3 col-xs-3" ></div>
                                            </div>

                                            <table width="100%" border="1" style="margin-bottom: 10px;font-size: 10px;margin-top: 10px;">
                                                <thead>
                                                    <tr>
                                                        <th style="width: 250px;">&nbsp;&nbsp;ROLL NO &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:<span style="font-weight: normal;">&nbsp;<?php echo $CurrentStudent->GetRollNumber(); ?></span></th>
                                                        <th style="width: 450px;">STUDENT'S NAME :<span style="font-weight: normal;"><?php echo $CurrentStudent->GetFirstName() . ' ' . $CurrentStudent->GetLastName(); ?></span></th>
                                                        <th style="text-align: left;width: 550px;"><span style="width: 30%;">&nbsp;FATHER'S NAME</span>&nbsp;:&nbsp;<span style="width: 40%; font-weight: normal;"><?php echo $CurrentParent->GetFatherFirstName() . ' ' . $CurrentParent->GetFatherLastName(); ?>&nbsp;&nbsp;</span></th>
                                                    </tr>
                                                    <tr>
                                                        <th style="width: 550px;">&nbsp;&nbsp;MOTHER'S NAME &nbsp;&nbsp;&nbsp;:<span style="font-weight: normal;width: 40%;">&nbsp;<?php echo $CurrentParent->GetMotherFirstName() . ' ' . $CurrentParent->GetMotherLastName(); ?></span></th>
                                                        <th>
                                                            &nbsp;CLASS &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:<span style="font-weight: normal;">&nbsp;<?php echo $CurrentClass->GetClassName() . ' ' . $CurrentSectionMaster->GetSectionName(); ?></span>
                                                        </th>
                                                        <th style="text-align: left;"><span style="width: 30%;">&nbsp;&nbsp;ADMISSION NO.</span>&nbsp;:&nbsp;<span style="width: 50%; font-weight: normal;"><?php echo $CurrentStudent->GetEnrollmentID(); ?>
                                                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></th>
                                                    </tr>
                                                    <tr>
                                                        <th colspan="3">&nbsp;&nbsp;DOB&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:<span style="font-weight: normal;">&nbsp;<?php echo ($CurrentStudent->GetDOB() != '0000-00-00') ? date('d/m/Y', strtotime($CurrentStudent->GetDOB())) : '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'; ?></span></th>
                                                    </tr>
                                                </thead>
                                            </table>
                                            <table width="100%" border="1" style="font-size: 12px; margin-bottom:10px;">
                                                <thead>
                                                    <!--<th colspan="5" style="text-align: center;">Term-II<sup>nd</sup></th><th style="text-align: center;">&nbsp;</th>-->
                                                    <!--<th colspan="3" style="text-align: center;">Term-II<sup>nd</sup></th><th style="text-align: center;">&nbsp;</th>-->
                                                <?php 
                                                    if($ClassNameForFormate <= 11)
                                                    {
                                                        echo '<tr>
                                                            <th></th>
                                                            <th class="text-center">SCHOLASTIC AREAS</th>
                                                            <th colspan="5" style="text-align: center;">Term-I<sup>st</sup></th>
                                                        </tr>';
                                                    }else{
                                                        echo '<tr>
                                                            <th></th>
                                                            <th class="text-center">SCHOLASTIC AREAS</th>
                                                            <th colspan="3" style="text-align: center;">Term-I<sup>st</sup></th>
                                                        </tr>';
                                                    }
                                                ?>
                                                    
                                                    <tr>
                                                        <th class="text-center">SN</th>
                                                        <th>&nbsp;&nbsp;SUBJECTS</th>
                                                        <?php

                                                        $ExamCounter = 0;
                                                        $GrandTotal = 0;
                                                        foreach ($AllHappendedExamList as $ExamTypeID => $Details) {
                                                            $SubjectCount = 0;
                                                            $ExamTypeMaximumMarks = 0;
                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $SubjectCount++;
                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }

                                                            $Marks = '<br>(80)';
                                                            if ($SubjectCount > 0) {
                                                                $GrandTotal += $ExamTypeMaximumMarks / $SubjectCount;
                                                                $Marks = '<br>(' . $ExamTypeMaximumMarks / $SubjectCount . ')';
                                                            }
                                                            if($Details['ExamName'] == 'HY'){
                                                                echo '<th style="text-align: center;">' . $Details['ExamName'] . $Marks . '</th>';
                                                            }else if ($Details['ExamName'] == 'CT1'){
                                                                echo '<th style="text-align: center;">' . $Details['ExamName'] . '<br>(10) </th>';
                                                            }else if($Details['ExamName'] == 'NB1' || $Details['ExamName'] == 'SE1'){
                                                                echo '<th style="text-align: center;">' . $Details['ExamName'] . '<br>(5) </th>';
                                                            }else {
                                                                echo '<th style="text-align: center;">' . $Details['ExamName'] . $Marks . '</th>';
                                                            }
                                                            $ExamCounter++;
                                                            
                                                           if($ClassNameForFormate <= 11)
                                                           {
                                                                if ($ExamCounter == 4 || $ExamCounter == 9)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<th style="text-align: center;">Total<br>(100)</th>';
                                                                }
                                                           }else{
                                                                if ($ExamCounter == 2 || $ExamCounter == 5)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<th style="text-align: center;">Total<br>(50)</th>';
                                                                }
                                                           }
                                                        }
                                                        // if($ClassNameForFormate <= 11)
                                                        //   {
                                                        //         echo '<th style="text-align: center;">Grand Total<br>(200)</th>';
                                                        //   }else{
                                                        //         echo '<th style="text-align: center;">Grand Total<br>(100)</th>';
                                                        //   }
                                                        ?>
                                                        
                                                        <!--<th style="text-align: center;">Total</th>-->
                                                    </tr>
                                                    <?php
                                                    $RowCounter = 1;
                                                    $AllSubjectsGrandTotalObtainedMarks = 0;
                                                    $AllSubjectsGrandTotalMaximumMarks = 0;
                                                    $IsFailInExamType = array();
                                                    $MininumMarks = 0;

                                                    $ReportCardSubjects = array();
                                                    $ReportCardSubjects = Exam::GetReportCardSubject($CurrentStudent->GetClassSectionID());

                                                    $firstTermGrandTotal = 0;
                                                    $secondTermGrandTotal = 0;
                                                    
                                                    $SubjectCount = 0;
                                                    foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                        if ($ClassSubjectDetails['SubjectMarksType'] == 'Grade' || !array_key_exists($ClassSubjectID, $ReportCardSubjects)) {
                                                            continue;
                                                        }
                                                        $SubjectCount++;
                                                    ?>
                                                        <tr>
                                                            <td style="text-align: center;"><?php echo $RowCounter++; ?></td>
                                                            <td style="text-align: left;">&nbsp;&nbsp;<?php echo $ClassSubjectDetails['Subject']; ?></td>
                                                            <?php
                                                            $GrandTotal = 0;
                                                            $SubjectObtainedMarksGrandTotal = 0;
                                                            $SubjectMaximumMarksGrandTotal = 0;

                                                            $Term1SubjectObtainedTotalMarks = 0;
                                                            $Term2SubjectObtainedTotalMarks = 0;

                                                            $ExamCounter = 0;
                                                            
                                                            $firstTermTotal = 0;
                                                            $secondTermTotal = 0;
                                                            
                                                            foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID);
                                                                if (count($SubjectMarks) == 0) {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;">-</td>';
                                                                    
                                                                    if($ClassNameForFormate <= 11)
                                                                    {
                                                                        if ($ExamCounter == 4)
                                                                        {
                                                                            $ExamCounter++;
                                                                            if($firstTermTotal == 0)
                                                                            {
                                                                                echo '<td style="text-align: center;">-</td>';
                                                                            }else{
                                                                                echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                            }
                                                                           
                                                                            $firstTermGrandTotal += $firstTermTotal;
                                                                        }
                                                                        
                                                                        if ($ExamCounter == 9)
                                                                        {
                                                                            $ExamCounter++;
                                                                            if($secondTermTotal == 0)
                                                                            {
                                                                                echo '<td style="text-align: center;">-</td>';
                                                                            }else{
                                                                                echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                            }
                                                                            $secondTermGrandTotal += $secondTermTotal;
                                                                        }
                                                                    }else{
                                                                        if ($ExamCounter == 2)
                                                                        {
                                                                            $ExamCounter++;
                                                                            if($firstTermTotal == 0)
                                                                            {
                                                                                echo '<td style="text-align: center;">-</td>';
                                                                            }else{
                                                                                echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                            }
                                                                            $firstTermGrandTotal += $firstTermTotal;
                                                                        }
                                                                        
                                                                        if ($ExamCounter == 5)
                                                                        {
                                                                            $ExamCounter++;
                                                                            if($secondTermTotal == 0)
                                                                            {
                                                                                echo '<td style="text-align: center;">-</td>';
                                                                            }else{
                                                                                echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                            }
                                                                            $secondTermGrandTotal += $secondTermTotal;
                                                                        }
                                                                    }
                                                                } else {
                                                                    foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                        if ($SubjectMarksDetails['Status'] != '' && $SubjectMarksDetails['Status'] != 'Present' && $ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                            $ExamCounter++;
                                                                            echo '<td style="text-align: center;">';
                                                                            echo $SubjectMarksDetails['Status'];
                                                                            echo '</td>';
                                                                            
                                                                           if($ClassNameForFormate <= 11)
                                                                           {
                                                                                if ($ExamCounter == 4)
                                                                                {
                                                                                    $ExamCounter++;
                                                                                    if($firstTermTotal == 0)
                                                                                    {
                                                                                        echo '<td style="text-align: center;">-</td>';
                                                                                    }else{
                                                                                        echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                                    }
                                                                                    $firstTermGrandTotal += $firstTermTotal;
                                                                                }
                                                                                
                                                                                if ($ExamCounter == 9)
                                                                                {
                                                                                    $ExamCounter++;
                                                                                    if($secondTermTotal == 0)
                                                                                    {
                                                                                        echo '<td style="text-align: center;">-</td>';
                                                                                    }else{
                                                                                        echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                                    }
                                                                                    $secondTermGrandTotal += $secondTermTotal;
                                                                                }
                                                                           }else{
                                                                                if ($ExamCounter == 2)
                                                                                {
                                                                                    $ExamCounter++;
                                                                                    if($firstTermTotal == 0)
                                                                                    {
                                                                                        echo '<td style="text-align: center;">-</td>';
                                                                                    }else{
                                                                                        echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                                    }
                                                                                    $firstTermGrandTotal += $firstTermTotal;
                                                                                }
                                                                                
                                                                                if ($ExamCounter == 5)
                                                                                {
                                                                                    $ExamCounter++;
                                                                                    if($secondTermTotal == 0)
                                                                                    {
                                                                                        echo '<td style="text-align: center;">-</td>';
                                                                                    }else{
                                                                                        echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                                    }
                                                                                    $secondTermGrandTotal += $secondTermTotal;
                                                                                }
                                                                            }
                                                                            
                                                                        } elseif ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                            if ($SubjectMarksDetails['Marks'] < $MininumMarks) {
                                                                                $IsFailInExamType[$ExamTypeID] = 1;
                                                                            }

                                                                            echo '<td style="text-align: center;" class="subject-marks">';

                                                                            $GrandTotal += $SubjectMarksDetails['Marks'];
                                                                            echo (int)$SubjectMarksDetails['Marks'];
                                                                            $ExamCounter++;
                                                                            
                                                                           if($ClassNameForFormate <= 11)
                                                                           {
                                                                                if ($ExamCounter < 5)
                                                                                {
                                                                                   if ($SubjectMarksDetails['Marks'] > 0 || $SubjectMarksDetails['Marks'] == 0)
                                                                                    {
                                                                                        $firstTermTotal += $SubjectMarksDetails['Marks'];
                                                                                    }else{
                                                                                        continue;
                                                                                    }
                                                                                
                                                                                }
                                                                                else
                                                                                {
                                                                                    $secondTermTotal += $SubjectMarksDetails['Marks'];
                                                                                }
                                                                           }else{
                                                                                if ($ExamCounter < 3)
                                                                                {
                                                                                    if ($SubjectMarksDetails['Marks'] > 0 || $SubjectMarksDetails['Marks'] == 0)
                                                                                    {
                                                                                        $firstTermTotal += $SubjectMarksDetails['Marks'];
                                                                                    }else{
                                                                                        continue;
                                                                                    }
                                                                                
                                                                                }
                                                                                else
                                                                                {
                                                                                    $secondTermTotal += $SubjectMarksDetails['Marks'];
                                                                                }
                                                                           }

                                                                            $Term1SubjectObtainedTotalMarks += $SubjectMarksDetails['Marks'];

                                                                            if ($ExamTypeID > 4) {
                                                                                $Term2SubjectObtainedTotalMarks += $SubjectMarksDetails['Marks'];
                                                                            }

                                                                            if ($ExamTypeID == 8) {
                                                                                //   echo '<td style="text-align: center;">'. $Term1SubjectObtainedTotalMarks .'</td>';

                                                                                $Grade = '';

                                                                                foreach ($AllGrades as $GradeID => $GradeDetails) {
                                                                                    if ($Term1SubjectObtainedTotalMarks >= $GradeDetails['FromPercentage'] && $Term1SubjectObtainedTotalMarks <= $GradeDetails['ToPercentage']) {
                                                                                        $Grade = $GradeDetails['Grade'];
                                                                                    } else if (($Term1SubjectObtainedTotalMarks < $GradeDetails['FromPercentage'] && $Term1SubjectObtainedTotalMarks > ($GradeDetails['FromPercentage'] - 1)) && ($Term1SubjectObtainedTotalMarks <= $GradeDetails['ToPercentage'])) {
                                                                                        $Grade = $GradeDetails['Grade'];
                                                                                    }
                                                                                }
                                                                            }

                                                                            $SubjectObtainedMarksGrandTotal += $SubjectMarksDetails['Marks'];

                                                                            $AllSubjectsGrandTotalObtainedMarks += $SubjectObtainedMarksGrandTotal;
                                                                            echo '</td>';
                                                                            
                                                                           if($ClassNameForFormate <= 11)
                                                                           {
                                                                            if ($ExamCounter == 4)
                                                                            {
                                                                                $ExamCounter++;
                                                                                echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                                $firstTermGrandTotal += $firstTermTotal;
                                                                            }
                                                                            
                                                                            if ($ExamCounter == 9)
                                                                            {
                                                                                $ExamCounter++;
                                                                                echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                                $secondTermGrandTotal += $secondTermTotal;
                                                                            }
                                                                           }else{
                                                                            if ($ExamCounter == 2)
                                                                            {
                                                                                $ExamCounter++;
                                                                                echo '<td style="text-align: center;">'.$firstTermTotal.'</td>';
                                                                                $firstTermGrandTotal += $firstTermTotal;
                                                                            }
                                                                            
                                                                            if ($ExamCounter == 5)
                                                                            {
                                                                                $ExamCounter++;
                                                                                echo '<td style="text-align: center;">'.$secondTermTotal.'</td>';
                                                                                $secondTermGrandTotal += $secondTermTotal;
                                                                            }
                                                                           }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            
                                                            if ($ExamTypeID == 9 && $SubjectObtainedMarksGrandTotal > 0) {
                                                                //echo '<td style="text-align: center;">' . $SubjectObtainedMarksGrandTotal . '</td>';

                                                                $Grade = '';

                                                                foreach ($AllGrades as $GradeID => $GradeDetails) {
                                                                    if ((($SubjectObtainedMarksGrandTotal) >= $GradeDetails['FromPercentage']) && (($SubjectObtainedMarksGrandTotal) <= $GradeDetails['ToPercentage'])) {
                                                                        $Grade = $GradeDetails['Grade'];
                                                                    }
                                                                }

                                                                // echo '<td style="text-align: center;">' . $Grade . '</td>';
                                                            }
                                                            // echo '<td style="text-align: center;" class="subject-marks">'.($firstTermTotal + $secondTermTotal).'</td>';
                                                            ?>
                                                        </tr>
                                                    <?php
                                                    }
                                                    
                                                    ?>
                                                    <tr>
                                                        <th colspan="2">&nbsp;&nbsp;TOTAL</th>
                                                        <?php
                                                        $StudentGrandTotal = 0;
                                                        $GrandTotalMarks = 0;

                                                        $Term1TotalMarks = 0;
                                                        $Term1MximumTotalMarks = 0;

                                                        $Term2TotalMarks = 0;
                                                        $Term2MximumTotalMarks = 0;

                                                        $ExamCounter = 0;
                                                        $totalNew = 0;
                                                        $totalNewFrom = 0;
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeObtainMarks = 0;
                                                            $ExamTypeMaximumMarks = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {

                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];

                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];

                                                                        $StudentGrandTotal += $SubjectMarksDetails['Marks'];
                                                                        $GrandTotalMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }

                                                            if ($ExamTypeID <= 9) {
                                                                $Term1TotalMarks += $ExamTypeObtainMarks;
                                                                $Term1MximumTotalMarks += $ExamTypeMaximumMarks;
                                                            } else {
                                                                $Term2TotalMarks += $ExamTypeObtainMarks;
                                                                $Term2MximumTotalMarks += $ExamTypeMaximumMarks;
                                                            }
                                                            
                                                            if ($ExamTypeObtainMarks > 0 || $ExamTypeObtainMarks == 0) {
                                                                $totalNew += $ExamTypeObtainMarks;
                                                                $totalNewFrom += $ExamTypeMaximumMarks;
                                                                echo '<td style="text-align: center;"><strong>' . $ExamTypeObtainMarks . '/' . $ExamTypeMaximumMarks . '</strong></td>';
                                                                // echo '<td style="text-align: center;"><strong></strong></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                            
                                                            
                                                            $ExamCounter++;
                                                            
                                                                if($ClassNameForFormate <= 11)
                                                                {
                                                                    if ($ExamCounter == 4)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.$firstTermGrandTotal.'/'.($SubjectCount * 100).'</strong></td>';
                                                                }
                                                                
                                                                if ($ExamCounter == 9)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.$secondTermGrandTotal.'/'.($SubjectCount * 100).'</strong></td>';
                                                                }
                                                            }else{
                                                                if ($ExamCounter == 2)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.$firstTermGrandTotal.'/'.($SubjectCount * 50).'</strong></td>';
                                                                }
                                                                
                                                                if ($ExamCounter == 5)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.$secondTermGrandTotal.'/'.($SubjectCount * 50).'</strong></td>';
                                                                }
                                                            }
                                                        }
                                                        // if($ClassNameForFormate <= 11)
                                                        // {
                                                        //     echo '<td style="text-align: center;"><strong>' . ($firstTermGrandTotal + $secondTermGrandTotal) . '/'.(($SubjectCount * 100) * 2).'</strong></td>';
                                                        // }else{
                                                        //     echo '<td style="text-align: center;"><strong>' . ($firstTermGrandTotal + $secondTermGrandTotal) . '/'.(($SubjectCount * 100)).'</strong></td>';
                                                        // }
                                                        
                                                        // echo '<td style="text-align: center;"><strong>' . ($totalNew) . '/'.$totalNewFrom.'</strong></td>';
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                        <th colspan="2">&nbsp;&nbsp;PERCENTAGE</th>
                                                        <?php
                                                        $StudentGrandTotal = 0;
                                                        $GrandTotalMarks = 0;

                                                        $ExamCounter = 0;
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeObtainMarks = 0;
                                                            $ExamTypeMaximumMarks = 0;
                                                            $ExamPercentage = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                    $TotalMaximumMarks = 0;
                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];
                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];

                                                                        $StudentGrandTotal += $SubjectMarksDetails['Marks'];
                                                                        $GrandTotalMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }

                                                            if (($ExamTypeObtainMarks > 0 || $ExamTypeObtainMarks == 0) && $ExamTypeMaximumMarks > 0) {
                                                                // echo '<td style="text-align: center;"><strong>'.$ExamTypeObtainMarks . $ExamTypeMaximumMarks.'%</strong></td>'; 
                                                                echo '<td style="text-align: center;"><strong>' . number_format((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100), 2) . '%</strong></td>';
                                                                // echo '<td style="text-align: center;"><strong></strong></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                            
                                                            $ExamCounter++;
                                                            
                                                           if($ClassNameForFormate <= 11)
                                                           {
                                                                if ($ExamCounter == 4)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.number_format((($firstTermGrandTotal / ($SubjectCount * 100)) * 100), 2).'%</strong></td>';
                                                                }
                                                                
                                                                if ($ExamCounter == 9)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.number_format((($secondTermGrandTotal / ($SubjectCount * 100)) * 100), 2).'%</strong></td>';
                                                                }
                                                           }else{
                                                                if ($ExamCounter == 2)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.number_format((($firstTermGrandTotal / ($SubjectCount * 50)) * 100), 2).'%</strong></td>';
                                                                }
                                                                
                                                                if ($ExamCounter == 5)
                                                                {
                                                                    $ExamCounter++;
                                                                    echo '<td style="text-align: center;"><strong>'.number_format((($secondTermGrandTotal / ($SubjectCount * 50)) * 100), 2).'%</strong></td>';
                                                                }
                                                           }
                                                        }
                                                        if($ClassNameForFormate <= 11)
                                                        {
                                                            $final_grade_percentage = number_format(((($firstTermGrandTotal + $secondTermGrandTotal) / (($SubjectCount * 100) * 2)) * 100), 2);
                                                        }else{
                                                            $final_grade_percentage = number_format((($firstTermGrandTotal + $secondTermGrandTotal) / (($SubjectCount * 100)) * 100), 2);
                                                        }
                                                       

                                                        // echo '<td style="text-align: center;"><strong>' . $final_grade_percentage . '%</strong></td>';
                                                        // echo '<td style="text-align: center;"><strong>' . number_format((($totalNew * 100) / $totalNewFrom), 2) . '%</strong></td>';
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                    <th colspan="3">&nbsp;&nbsp;Overall Grade</th>
                                                    <!--<td colspan="11">-->
                                                    <!--    <strong>-->
                                                                <?php
                                                                    // foreach ($AllGrades as $grade_details){
                                                                    //     if ($final_grade_percentage >= $grade_details['FromPercentage'] && $final_grade_percentage <= $grade_details['ToPercentage'])
                                                                    //     {
                                                                    //         echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$grade_details['Grade'];
                                                                    //         break;
                                                                    //     }
                                                                    // }
                                                                ?>
                                                    <!--    </strong>-->
                                                    <!--</td>-->
                                                    </tr>
                                                    <!--code start for rank-->
                                                    <!--
                                                    <tr>
                                                            <th colspan="2">&nbsp;&nbsp;RANK</th>
                                                <?php
                                                foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                    $ExamTypeObtainMarks = 0;
                                                    $ExamTypeMaximumMarks = 0;
                                                    $ExamPercentage = 0;

                                                    foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                        $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID);

                                                        foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                            $TotalMaximumMarks = 0;

                                                            if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];
                                                                $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];
                                                            }
                                                        }
                                                    }

                                                    // if ($ExamTypeObtainMarks > 0) 
                                                    // {
                                                    //     if (array_key_exists($ExamTypeID, $IsFailInExamType))
                                                    //     {
                                                    //         echo '<td style="text-align: center;"><strong><span style="color:red;">Failed</span></strong></td>';
                                                    //     }
                                                    //     else
                                                    //     {
                                                    //         echo '<td style="text-align: center;"> '.((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100) >= 40.0 ? StudentExamMark::GetStudentRankInClass($ExamTypeID, $CurrentStudent->GetClassSectionID(), $MininumMarks, $StudentID) : '').' ';
                                                    //         echo '<strong>'.((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100) >= 40.0 ? 'Passed' : '<span style="color:red;">Failed</span>').'</strong></td>';   
                                                    //     }
                                                    // }
                                                    // else
                                                    // {
                                                    //     echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                    // }

                                                    echo '<td style="text-align: center;"></td>';

                                                    if ($ExamTypeID == 4) {
                                                        echo '<td style="text-align: center;"></td>';
                                                        echo '<td style="text-align: center;"></td>';
                                                    }

                                                    if ($ExamTypeID == 8) {
                                                        echo '<td style="text-align: center;"></td>';
                                                        echo '<td style="text-align: center;"></td>';
                                                        echo '<td style="text-align: center;"></td>';
                                                        echo '<td style="text-align: center;"></td>';
                                                    }
                                                }
                                                ?>
                                                        </tr> 
                                                        -->
                                                    <!--code end for rank-->

                                                    <tr>
                                                        <!--<th colspan="2">&nbsp;&nbsp;POSITION </th>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <!--<td style="text-align: center;"></td>-->
                                                        <?php
                                                        if ($ExamTypeID == 8 && false) {
                                                        ?>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                            <td style="text-align: center;"></td>
                                                        <?php
                                                        }
                                                        ?>
                                                    </tr>
                                                </thead>
                                            </table>

                                            <table width="100%" border="1" style="margin-top: 10px;font-size: 12px; margin-bottom:10px;">
                                                <thead>
                                                    <tr>
                                                        <th style="font-size: 12px;font-weight: bold;">&nbsp;&nbsp;CO SCHOLASTIC AREAS TERM-II <br>
                                                            [ ON A 3-POINT(A-C) GRADING SCALE ] </th>
                                                        <th style="text-align: center;font-size: 12px;">GRADE</th>
                                                        <?php
                                                        if ($ExamTypeID == 8) {
                                                        ?>
                                                            <!--<th style="font-size: 12px;">&nbsp;&nbsp;CO SCHOLASTIC AREAS TERM-2<br>-->
                                                            <!--  &nbsp;&nbsp;&nbsp;[ ON A 3-POINT(A-C) GRADING SCALE ]</th>-->
                                                            <!--<th style="text-align: center;">GRADE</th>-->
                                                        <?php
                                                        }
                                                        ?>
                                                    </tr>

                                                    <?php
                                                    $RowCounter = 0;

                                                    $ReportCardGradeSubjects = array();
                                                    $ReportCardGradeSubjects = Exam::GetReportCardSubject($CurrentStudent->GetClassSectionID());

                                                    foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                        if ($ClassSubjectDetails['SubjectMarksType'] != 'Grade' || !array_key_exists($ClassSubjectID, $ReportCardSubjects)) {
                                                            continue;
                                                        }

                                                        echo '<tr>';
                                                        echo '<td>';
                                                        echo '&nbsp; ' . $ClassSubjectDetails['Subject'];
                                                        echo '</td>';

                                                        $SubjectMarks = StudentExamMark::GetStudentSubjectMarks(9, $ClassSubjectID, $StudentID);

                                                        if (count($SubjectMarks) == 0) {
                                                            echo '<td style="text-align: center;">---</td>';
                                                        } else {
                                                            foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                if ($ClassSubjectDetails['SubjectMarksType'] == 'Grade') {
                                                                    echo '<td style="text-align: center;">';
                                                                    if ($SubjectMarksDetails['Grade'] != '') {
                                                                        echo $SubjectMarksDetails['Grade'];
                                                                    } else {
                                                                        echo 'Absent';
                                                                    }
                                                                    echo '</td>';
                                                                }
                                                            }
                                                        }
                                                        if ($ExamTypeID == 8) {
                                                            // echo '<td style="text-align:center;">'; 
                                                            // echo '&nbsp; '. $ClassSubjectDetails['Subject'];
                                                            // echo '</td>';
                                                            //     $SubjectMarks = StudentExamMark::GetStudentSubjectMarks(8, $ClassSubjectID, $StudentID);

                                                            //     if (count($SubjectMarks) == 0) 
                                                            //     {
                                                            //         echo '<td style="text-align: center;">-</td>';
                                                            //     }
                                                            //     else
                                                            //     {
                                                            //         foreach ($SubjectMarks as $key => $SubjectMarksDetails) 
                                                            //         {
                                                            //             if ($ClassSubjectDetails['SubjectMarksType'] == 'Grade') 
                                                            //             {
                                                            //                 echo '<td style="text-align: center;">';
                                                            //                 echo $SubjectMarksDetails['Grade'];
                                                            //                 echo '</td>';
                                                            //             }
                                                            //         }
                                                            //     }   
                                                        }
                                                    ?>
                                                        </tr>
                                                    <?php
                                                    }
                                                    ?>

                                                </thead>
                                            </table>

                                            <table width="100%" border="1" style="margin-top: 10px;">
                                                <thead>
                                                    <tr style="font-size: 12px;">
                                                        <th style="font-size: 12px;font-weight: bold;">&nbsp;&nbsp;DISCIPLINE TERM-II<br>
                                                            &nbsp;&nbsp;&nbsp;[ ON A 3-POINT(A-C) GRADING SCALE ]</th>
                                                        <th style="text-align: center;font-size: 12px;">GRADE</th>
                                                        <?php
                                                        if ($ExamTypeID == 8) {
                                                        ?>
                                                            <!--<th style="font-size: 12px;">&nbsp;&nbsp;DISCIPLINE TERM-2<br>-->
                                                            <!--  &nbsp;&nbsp;&nbsp;[ ON A 3-POINT(A-C) GRADING SCALE ]</th>-->
                                                            <!--<th style="text-align: center;">GRADE</th>-->
                                                        <?php
                                                        }
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                        <td style="font-size: 12px;">&nbsp;&nbsp;DISCIPLINE</td>
                                                        <td style="text-align: center;">&nbsp;&nbsp;</td>
                                                        <?php
                                                        if ($ExamTypeID == 8) {
                                                        ?>
                                                            <!--<td style="text-align: left;font-size: 12px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;DISCIPLINE</td>-->
                                                            <!--<td style="text-align: center;">&nbsp;&nbsp;</td>-->
                                                        <?php
                                                        }
                                                        ?>
                                                    </tr>
                                                </thead>
                                            </table>

                                            <table width="100%" border="1" style="margin-top: 3px;font-size: 12px; margin-bottom:0px!important;">
                                                <thead>
                                                    <tr>
                                                        <td style="text-align: left;width: 535px;">&nbsp;&nbsp;ATTENDANCE</td>
                                                        <td style="text-align: center;width: 99px;">&nbsp;&nbsp;</td>
                                                        <?php
                                                        if ($ExamTypeID == 8) {
                                                        ?>
                                                            <td style="text-align: center;width: 585px;"></td>
                                                            <td style="text-align: center;"></td>
                                                        <?php
                                                        }
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                    <!--<td style="text-align: left;width: 535px;">&nbsp;&nbsp;PROMOTED TO : </td>-->
                                                    <!--<td style="text-align: center;width: 99px; font-weight:bold;">&nbsp;&nbsp; <?php //echo $NextClassName; ?></td>-->
                                                    </tr>
                                                </thead>
                                            </table>

                                            <table width="100%" border="1">
                                                <tr colspan="2" style="height: 30px;font-size: 12px;">
                                                    <th>&nbsp;&nbsp;CLASS TEACHER'S REMARKS:</th>
                                                    <?php
                                                    if ($ExamTypeID == 8) {
                                                        // echo '<th>&nbsp;&nbsp;CLASS TEACHER`S REMARKS:</th>';                                                  
                                                    }
                                                    ?>
                                                </tr>
                                                <tr colspan="2" style="font-size: 12px;">
                                                    <?php
                                                    $NextClassName = '';
                                        
                                                    if ($CurrentClassSections->GetClassID() < 15)
                                                    {
                                                        $NextClass = new AddedClass($CurrentClassSections->GetClassID() + 1);
                                                        
                                                        $NextClassName = $NextClass->GetClassName();
                                                    }
                                                    else
                                                    {
                                                        $NextClassName = 'Passout';
                                                    }
                                                    
                                                    if ($NextClassName != '' && strpos($NextClassName, 'CLASS') == false)
                                                    {
                                                        $NextClassName = 'CLASS-'.$NextClassName;
                                                    }
                                                    
                                                    $NextClassName = str_replace("CLASS-CLASS","CLASS",$NextClassName);
                                                    
                                                    ?>
                                                    <!--<th>&nbsp;&nbsp;Promoted To Class:&nbsp;&nbsp;&nbsp;&nbsp;<?php //echo $NextClassName; ?></th>-->
                                                </tr>
                                                <?php
                                                if ($ExamTypeID == 8) {
                                                ?>
                                                    <tr colspan="2" style="font-size: 12px;">
                                                        <th>&nbsp;&nbsp;PASSESD & Promoted to Class: &nbsp;</th>
                                                        <th>&nbsp;&nbsp;SCHOOL REOPENS ON: &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</th>
                                                    </tr>
                                                <?php
                                                }
                                                ?>
                                            </table>

                                            <table width="100%" border="1" style="margin-top: 5px">
                                                <tr colspan="2" style="font-size: 12px; font-weight: bold;">
                                                    <td style="width: 250px;">PLACE<br><br>DATE</td>
                                                    <td style="text-align: center;padding-top: 40px;width: 250px;">CLASS TEACHER</td>
                                                    <td style="text-align: center;padding-top: 40px;width: 250px;">PRINCIPAL</td>
                                                    <td style="text-align: center;padding-top: 40px;width: 250px;">PARENTS</td>
                                                </tr>
                                            </table>

                                            <div class="row" style="margin-top: 20px;font-size: 11px; margin-bottom:0px; padding-bottom:60px;">
                                                <div class="col-lg-12 col-md-12 col-12 col-sm-12 col-xs-12" >
                                                    <table width="70%" border="1" style=" margin: auto; margin-bottom:0px;padding-bottom:0px;">
                                                        <thead>
                                                            <tr>
                                                                <th colspan="6" style="text-align: center;">INSTRUCTIONS</th>
                                                            </tr>
                                                            <tr>
                                                                <th style="text-align: center;" colspan="4">GRADING SCALE FOR SCHOLASTIC AREAS 8-POINT GRADING SCALE</th>
                                                            </tr>
                                                            <tr>
                                                                <th style="text-align: center;">MARKS RANGE</th>
                                                                <th style="text-align: center;">GRADE</th>
                                                            </tr>
                                                            <?php
                                                            $RowCounter = 0;

                                                            foreach ($AllGrades as $GradeDetails) {
                                                                if ($GradeDetails['FromPercentage'] == 0 && $GradeDetails['ToPercentage'] == 0) {
                                                                    continue;
                                                                }

                                                                // if ($RowCounter == 0) {
                                                                    echo '<tr>';
                                                                // }

                                                                $GradeType = '';

                                                                echo '<th style="text-align:center;">';
                                                                echo '&nbsp;(' . $GradeDetails['FromPercentage'] . ' - ' . $GradeDetails['ToPercentage'] . $GradeType . ')';

                                                                if ($GradeDetails['Grade'] == 'E') {
                                                                    if ($CurrentClassSections->GetClassID() >= 12) {
                                                                        $GradeType = '(FAILED)';
                                                                    } else {
                                                                        $GradeType = '(NEEDS IMPROVEMENT)';
                                                                    }
                                                                }

                                                                echo '<th style="text-align:center;">';
                                                                echo '&nbsp; ' . $GradeDetails['Grade'] . $GradeType;
                                                                echo '</th>';
                                                                echo '</th>';
                                                                $RowCounter++;

                                                                if ($RowCounter > 1) {
                                                                    echo '</tr>';
                                                                    $RowCounter = 0;
                                                                }
                                                            }
                                                            ?>
                                                        </thead>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>   
                                        <div style="page-break-after: always;"></div> 
                                        <?php
                                        }
                                        ?> 
                                        
                                    </div> 
                                    
                                </div>
                                
                            <!-- /.panel-body -->
                        </div>
                        <!-- /.panel -->
                    </div>
                </div>
            </div>
        </div>
        <?php
        require_once('../footer.php');
        ?>
       <script>
                function myFunction() {
                    window.print();
                }
            </script>
</body>

</html>