<?php
ob_start();
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");
require_once("../../classes/class.date_processing.php");

require_once("../../classes/class.helpers.php");

require_once("../../classes/school_administration/class.branch_staff.php");
require_once("../../classes/school_administration/class.class_time_table.php");

require_once("../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:../unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:../unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

// if ($LoggedUser->HasPermissionForTask(TASK_VIEW_TEACHER_TIMETABLE) !== true)
// {
//     header('location:/admin/unauthorized_login_admin.php');
//     exit;
// }

$HasSearchErrors = false;
$HasErrors = false;

$StaffCategory = array();
$StaffCategory = array('Teaching' => 'Teaching Staff', 'NonTeaching' => 'Non Teaching Staff');

$AllBranchStaffList = array();
$AppLogDetails = array();

$Clean = array();

$Clean['BranchStaffID'] = 0;

$Clean['StaffCategory'] = 'Teaching';

$Clean['Process'] = 0;
$Clean['SelectDate'] = date('d/m/Y');

$AllBranchStaffList = BranchStaff::GetActiveBranchStaff($Clean['StaffCategory']);

if (isset($_POST['hdnProcess']))
{
    $Clean['Process'] = (int) $_POST['hdnProcess'];
}
switch ($Clean['Process'])
{   
    case 7:
        if (isset($_POST['drdStaffCategory']))
        {
            $Clean['StaffCategory'] = strip_tags(trim($_POST['drdStaffCategory']));
        }
            
        if (isset($_POST['drdBranchStaff']))
        {
            $Clean['BranchStaffID'] = (int) $_POST['drdBranchStaff'];
        }
        
        if (isset($_POST['txtSelectDate']))
		{
			$Clean['SelectDate'] =  strip_tags(trim($_POST['txtSelectDate']));
		}

        $SearchRecordValidator = new Validator();

        $SearchRecordValidator->ValidateInSelect($Clean['StaffCategory'], $StaffCategory, 'Unknown error, please try again.');
        
        $SearchRecordValidator->ValidateDate($Clean['SelectDate'], "Please enter a valid date.");
        
        if ($SearchRecordValidator->HasNotifications())
        {
            $HasSearchErrors = true;
            break;
        }

        $AllBranchStaffList = BranchStaff::GetActiveBranchStaff($Clean['StaffCategory']);
        $SearchRecordValidator->ValidateInSelect($Clean['BranchStaffID'], $AllBranchStaffList, 'Unknown error, please try again.');
        
        $dataPoints = Helpers::GetTeacherAppLog($Clean['BranchStaffID'], date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($Clean['SelectDate'])))));
        
        if (count($dataPoints) <= 0)
        {
            $dataPoints = array( 
                            array("label"=>"Oops! No Records Found", "y"=>100)
                            );
        }
        // $dataPoints = array( 
        //     array("label"=>"Chrome", "y"=>12),
        //     array("label"=>"Play Store", "y"=>8),
        //     array("label"=>"Facebook", "y"=>30),
        //     array("label"=>"Twitter", "y"=>6),
        //     array("label"=>"Teachers'App", "y"=>4),
        //     array("label"=>"whatsapp", "y"=>4),
        //     array("label"=>"Call", "y"=>2)
        // );
        
        // echo '<pre>';
        // var_dump($dataPoints);exit;

  }

  require_once('../html_header.php');
?>
<!DOCTYPE HTML>
<html>
<head>
<title>Teacher App Activity Log</title>
<link href="../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">

</head>
<body>
    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../site_header.php');
            require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">App Log Details</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="panel panel-default">
                <div class="panel-heading">
                     App Details
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" action="app_activity_log.php" method="post">
<?php
                    if ($HasSearchErrors == true)
                    {
                        echo $SearchRecordValidator->DisplayErrors();

                    }
?>
                        <div class="form-group">
                             <label for="StaffCategory" class="col-lg-2 control-label">Select Category</label>
                            <div class="col-lg-3">
                                <select class="form-control" name="drdStaffCategory" id="StaffCategory">
<?php
                                foreach ($StaffCategory as $Key => $StaffCategoryName)
                                {
?>
                                    <option <?php echo ($Key == $Clean['StaffCategory'] ? 'selected="selected"' : ''); ?> value="<?php echo $Key; ?>"><?php echo $StaffCategoryName; ?></option>
<?php
                                }
?>
                                </select>
                            </div>
                            
                             <label for="BranchStaffID" class="col-lg-2 control-label">Select BranchStaff</label>
                            <div class="col-lg-3">
                                <select class="form-control" name="drdBranchStaff" id="BranchStaffID">
<?php
                                foreach ($AllBranchStaffList as $BranchStaffID => $BranchStaffDetails)
                                {
?>
                                    <option <?php echo ($BranchStaffID == $Clean['BranchStaffID'] ? 'selected="selected"' : ''); ?> value="<?php echo $BranchStaffID; ?>"><?php echo $BranchStaffDetails['FirstName'] .' ' . $BranchStaffDetails['LastName']; ?></option>
<?php
                                }
?>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <label for="SelectDate" class="col-lg-2 control-label">Date</label>
                            <div class="col-lg-3">
                            	<input type="text" class="form-control dtepicker" maxlength="10" id="SelectDate" name="txtSelectDate" value="<?php echo $Clean['SelectDate']; ?>"/>
                            </div>

                            <div class="col-sm-offset-1 col-lg-2">
                                <input type="hidden" name="hdnProcess" value="7"/>
                                <button type="submit" class="btn btn-primary">Search</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
<?php
            if ($Clean['Process'] == 7 && $HasSearchErrors == false)
            {
?>      

                <br>
                <div id="chartContainer" style="height: 520px; width: 100%; margin-bottom:50px;">
                    
                </div>
                <script src="https://canvasjs.com/assets/script/canvasjs.min.js"></script>
<?php
            }
?>

            </div>
            <!-- /#page-wrapper -->

            </div>
<?php
require_once('../footer.php');
?>
<!-- JavaScript To Print A Report -->
<script src="/admin/js/print-report.js"></script>
<script>
window.onload = function() 
{
var chart = new CanvasJS.Chart("chartContainer", {
    animationEnabled: true,
    title: {
        text: "App Details"
    },
    subtitles: [{
        text: ""
    }],

    data: [{
        type: "pie",
        // yValueFormatString: "#,##0.00\"%\"",
        yValueFormatString: "#,##0.00\"%\"",
        indexLabel: "{label} ({y})",
        dataPoints: <?php echo json_encode($dataPoints, JSON_NUMERIC_CHECK); ?>
    }]
    
});
chart.render();

}
</script>
<script src="/admin/vendor/jquery-ui/jquery-ui.min.js"></script>
<script type="text/javascript">
$(document).ready(function() {
    $(".dtepicker").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy'
	});
});

$(function()
    {   
        $('#StaffCategory').change(function()
        {
            StaffCategory = $(this).val();
            
            if (StaffCategory <= 0)
            {
                $('#BranchStaffID').html('<option value="0">Select Section</option>');
                return false;
            }
            
            $.post("/xhttp_calls/get_branch_staff_by_staff_category.php", {SelectedStaffCategory:StaffCategory}, function(data)
            {
                ResultArray = data.split("|*****|");
                
                if (ResultArray[0] == 'error')
                {
                    alert(ResultArray[1]);
                }
                else
                {
                    $('#BranchStaffID').html(ResultArray[1]);
                }
            });
        });
    });
</script>

</body>
</html>                              