<?php
require_once("../../../classes/class.users.php");
require_once("../../../classes/class.validation.php");
require_once("../../../classes/class.authentication.php");

require_once('../../../classes/school_administration/class.academic_years.php');
require_once("../../../classes/school_administration/class.students.php");
require_once("../../../classes/school_administration/class.parent_details.php");
require_once("../../../classes/school_administration/class.student_details.php");

require_once("../../../classes/school_administration/class.classes.php");
require_once("../../../classes/school_administration/class.section_master.php");
require_once("../../../classes/school_administration/class.class_sections.php");

require_once("../../../classes/academic_supervision/class.achievements_master.php");

require_once("../../../classes/class.date_processing.php");
require_once("../../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

$Clean = array();

$Clean['StudentID'] = 0;

if (isset($_GET['StudentID']))
{
    $Clean['StudentID'] = (int) $_GET['StudentID'];
}
elseif (isset($_POST['hdnStudentID']))
{
    $Clean['StudentID'] = (int) $_POST['hdnStudentID'];
}

if ($Clean['StudentID'] <= 0)
{
    header('location:../../error.php');
    exit;
}   

try
{
    $StudentObject = new StudentDetail($Clean['StudentID']);    
}
catch (ApplicationDBException $e)
{
    header('location:../../error.php');
    exit;
}
catch (Exception $e)
{
    header('location:../../error.php');
    exit;
}

$HasErrors = false;

$AcademicYearID = 0;
$AcademicYearName = '';

$AcademicYearID = AcademicYear::GetCurrentAcademicYear($AcademicYearName);

$Clean['Process'] = 0;

$Clean['ClassSectionID'] = 0;
$Clean['ClassID'] = 0;
$Clean['Class'] = '';

$Clean['FirstName'] = '';
$Clean['LastName'] = '';

$Clean['Achievement'] = '';

$Clean['DOB'] = '';
$Clean['Gender'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$SchoolName = 'MARY GARDINER`S CONVENT SCHOOL';
$Address1 = 'Sec-P, Mansarovar Yojna';
$AffilationDetails = 'Near B.R, Ambedkar University';
$Address = 'Kanpur Road,Lucknow';
$Pincode = 229309;
$City = 'Amethi';
$State = 'UP';
$ContactNumber = '0535-2634282';
$AffilationNumber = '2132953';

if (isset($_POST['hdnProcess']))
{
    $Clean['Process'] = (int) $_POST['hdnProcess'];
}
else if (isset($_GET['Process']))
{
    $Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
    case 2:
      
        $Clean['ClassSectionID'] = $StudentObject->GetClassSectionID();

        $ClassSectionDetails = new ClassSections($StudentObject->GetClassSectionID());
        
        $ClassObject = new AddedClass($ClassSectionDetails->GetClassID());
        $Clean['Class'] = $ClassObject->GetClassName();

        $AchivementObject = new AchievementMaster();
        $Clean['Achievement'] = $AchivementObject->GetAchievement();

        $Clean['FirstName'] = $StudentObject->GetFirstName();
        $Clean['LastName'] = $StudentObject->GetLastName();
        $Clean['DOB'] = date('d/m/Y', strtotime($StudentObject->GetDOB()));
        $Clean['Gender'] = $StudentObject->GetGender();        

        $Clean['Address'] = $StudentObject->GetAddress1();

        if ($Clean['Address'] == '') 
        {
            $Clean['Address'] = $StudentObject->GetAddress2();         
        }        
       
        $NewParentDetail = new ParentDetail($StudentObject->GetParentID());

        $Clean['FatherFirstName'] = $NewParentDetail->GetFatherFirstName();
        $Clean['FatherLastName'] = $NewParentDetail->GetFatherLastName();
        $Clean['MotherFirstName'] = $NewParentDetail->GetMotherFirstName();
        $Clean['MotherLastName'] = $NewParentDetail->GetMotherLastName();

    break;
}

require_once('../../html_header.php');
?>
<title>Certificate Of Participation</title>
<link href="../../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>
<body>
    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../../site_header.php');
            require_once('../../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Certificate Of Participation</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <strong>Participation Certificate</strong>
                </div>
                <div class="panel-body">
                    <div>
                        <div class="row">
                            <div class="col-lg-6">                                     
                            </div>
                            <div class="col-lg-6">
                                <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                            </div>
                        </div>
                        <div id="RecordTableHeading">
                            <center>
                        <div class="align-center" style="position: relative; width:750px; height:550px; border:10px solid black; display:block; border-collapse: collapse;">
                                <div class="align-center" style="position: relative; border:3px solid gray; display:block; margin: 5px; height:520px;">
                                     <style type="text/css">
                                        #CurvedText {
                                          font-family: 'Luckiest Guy', cursive;
                                          font-size: 21.7px;
                                        }

                                        path {
                                          fill: transparent;
                                        }

                                        text {
                                          fill: #322429;
                                          font-weight:22px;
                                        }
                                    </style>
                                    <div style="height:90px; width:700px; float:left;text-align:center;background: white;" id="CurvedText">
                                        <svg viewBox="-20 30 500 600">
                                            <path id="curve" d="M73.2,148.6c4-6.1,65.5-96.8,178.6-95.6c111.3,1.2,170.8,90.3,175.1,97" />
                                            <text width="500">
                                              <textPath xlink:href="#curve">
                                                <?php echo $SchoolName; ?>
                                              </textPath>
                                            </text>
                                        </svg>
                                    </div>
                                    <div style="height:90px;text-align:center;margin-left: 30px;">
                                         <br><strong style="font-size:17px;"><?php echo $Address1; ?></strong>
                                         <br><strong style="font-size:17px;"><?php echo $AffilationDetails; ?></strong>
                                        <br><strong style="font-size:17px;"><?php echo $Address; ?></strong><br>
                                    <img src="../../../site_images/school_logo/logo.png" height="90px;" width="130px;" style="margin-top: 6px;">
                                    </div>
                                    <div style="margin-top: 170px; margin-left: 10px;">
                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">This is certified that <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 200px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FirstName'] .' '. $Clean['LastName'] ;?></b></span>S/o, D/o Shri.&nbsp; <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 185px; "><b><?php echo $Clean['FatherFirstName'] .' '. $Clean['FatherLastName'] ;?></b></span>&nbsp; </p>
                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">of Class <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 170px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Class'] ;?></b></span> Participated in &nbsp; <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 320px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Achievement'] ;?></b></span></p>
                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">and secured/awarded <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 360px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;</b></span>&nbsp; place during the </p>
                                        <p style="font-family: cursive; font-size:18px;  margin-top: 10px; display: flex;">session<span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 300px; "><b><?php echo $AcademicYearName ;?></b></span></p>
                                    </div>
                                    <div style="margin-top: 30px; margin-left: 20px;">
                                        <div style="font-family: cursive; font-size:18px; float: left; font-weight: 22px; margin-top: 10px; display: flex;"> We wish him/her successful future.</div>
                                        <div style="font-size:22px;float: right; font-weight: 22px; margin-top: 10px; margin-right: 70px; display: flex;">PRINCIPAL</div>
                                    </div>
                                </div>
                            </center>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../../footer.php');
?>
<script src="../../js/print-report.js"></script>
<script type="text/javascript">
    $(document).ready(function () {
        $('.unique-function').click(function () {

            var DataValue = prompt('Enter Details', $(this).text().trim());
            if (DataValue)
            {
                $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
            }
        });
    });
</script>
</body>
</html>