<?php
// error_log('webhook_response');
// error_log(json_encode($_REQUEST));

header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');

//Other Required Classess
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.api_helpers.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/fee_management/class.fee_transactions.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/fee_management/class.fee_collection.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.parent_details.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.parent_details.php');

$Response = new JSONResponse();

$Clean = array();
$Filters = array();

$Clean['Token'] = '';

//	Other Variables
$Clean['StudentID'] = 0;

$Clean['CentralFeeTransactionID'] = 0; 
$Clean['TransactionID'] = 0;   

$Clean['PaymentStatus'] = 'Pending';   
$Clean['EasePayID'] = '';   

$Clean['StudentFeetructureID'] = array();
$Clean['DueAmount'] = array();

$Clean['FeeCollectionDetails'] = array();

$TransactionID = 0;

if (isset($_REQUEST['udf1']))
{
	$Clean['Token'] = strip_tags(trim((string) $_REQUEST['udf1']));
}

if (isset($_REQUEST['udf2']))
{
	$Clean['StudentID'] = (int) $_REQUEST['udf2'];
}

if (isset($_REQUEST['udf3']))
{
    $Clean['StudentFeetructureID'] = explode(',', $_REQUEST['udf3']);
}

if (isset($_REQUEST['udf4']))
{
    $Clean['DueAmount'] = explode(',', $_REQUEST['udf4']);
}

if (isset($_REQUEST['txnid']))
{
	$Clean['CentralFeeTransactionID'] = (int) $_REQUEST['txnid'];
}

if (isset($_REQUEST['txnid']))
{
	$Clean['TransactionID'] = (int) $_REQUEST['txnid'];
}

if (isset($_REQUEST['status']))
{
	$Clean['PaymentStatus'] = strip_tags(trim((string) $_REQUEST['status']));
}   

if (isset($_REQUEST['easepayid']))
{
	$Clean['EasePayID'] = strip_tags(trim((string) $_REQUEST['easepayid']));
}   

try
{
	$LoggedInParent = new AppParentDetail($Clean['Token']);
    
    if (!array_key_exists($Clean['StudentID'], $LoggedInParent->GetApplicableStudents())) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	$StudentFeeStructureIDList = array();
	$StudentDiscountList = array();
	$DueAmountList = array();
	
	$FeeDetails = array();
	$FeeDetails = $LoggedInParent->GetStudentFeeDetails($Clean['StudentID']);
	
	$Counter = 0;
	foreach ($FeeDetails as $Month => $Details) 
	{
	    $DiscountValue = array_column($Details, 'DiscountValue');
	    $DueAmount = array_column($Details, 'DueAmount');
	    
	    foreach (array_column($Details, 'StudentFeeStructureID') as $key => $StudentFeeStructureID)
	    {
	        $StudentFeeStructureIDList[$StudentFeeStructureID] = $StudentFeeStructureID;
	        $StudentDiscountList[$StudentFeeStructureID] = $DiscountValue[$key];
	        $DueAmountList[$StudentFeeStructureID] = $DueAmount[$key];
	    }
	}
    
	if (count($Clean['StudentFeetructureID']) != count($Clean['DueAmount']))
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	if ($Clean['CentralFeeTransactionID'] <= 0) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	$TotalDiscount = 0;
	$StudentAmountPaid = 0;
	$StudentAmountPayable = 0;
	
	foreach ($Clean['StudentFeetructureID'] as $Key => $StudentFeeStructureID) 
	{
	    if (!array_key_exists($StudentFeeStructureID, $StudentFeeStructureIDList))
        {
            $Response->SetError(1);
            $Response->SetErrorCode(UNKNOWN_ERROR);
            $Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

            echo json_encode($Response->GetResponseAsArray());
            exit;
        }
        
        $FeeHeadPayableAmount = 0;
        if (array_key_exists($Key, $Clean['DueAmount']))
        {
            $FeeHeadPayableAmount = $Clean['DueAmount'][$Key];   
        }
        
        $Clean['FeeCollectionDetails'][$Clean['StudentID']]['StudentFeeCollectionDetails'][$StudentFeeStructureID] = $FeeHeadPayableAmount;
        
		$StudentAmountPayable += $FeeHeadPayableAmount;
		$StudentAmountPaid += $FeeHeadPayableAmount;
		
		$TotalDiscount += $StudentDiscountList[$StudentFeeStructureID];
	}
	
	$Clean['FeeCollectionDetails'][$Clean['StudentID']]['TotalDiscount'] = $TotalDiscount;
	$Clean['FeeCollectionDetails'][$Clean['StudentID']]['StudentAmountPaid'] = $StudentAmountPaid; // In table afm_fee_collection  amountPaid column
	$Clean['FeeCollectionDetails'][$Clean['StudentID']]['StudentAmountPayable'] = $StudentAmountPayable; // In table afm_fee_collection  totalAmount column
    
    // set PaymentMode  1 = Cash, 2 = Cheque, 3 = Net Transfer, 4 = Bank Transfer, 5 = Card Payment, 6 = Advance
    
    $Clean['PaymentModeDetails'][1]['PaymentMode'] = 5;
	$Clean['PaymentModeDetails'][1]['Amount'] = $StudentAmountPaid;
	$Clean['PaymentModeDetails'][1]['ChequeReferenceNo'] = '';
	$Clean['PaymentModeDetails'][1]['ChequeDate'] = '0000-00-00';
	$Clean['PaymentModeDetails'][1]['BankID'] = 0;
	
	if ($Clean['PaymentStatus'] == 'success')
	{
	    if (count($Clean['FeeCollectionDetails']) > 0)
        {
            $NewFeeCollection = new FeeCollection();
    	
    		$NewFeeCollection->SetStudentID($Clean['StudentID']);
    		$NewFeeCollection->SetFeeDate(date('Y-m-d'));
    
    		$NewFeeCollection->SetTransactionAmount($StudentAmountPaid); // In afm_fee_transactions transactionAmount
    
            $NewFeeCollection->SetTotalAmount($StudentAmountPayable);
    		$NewFeeCollection->SetTotalDiscount($TotalDiscount);
    		$NewFeeCollection->SetAmountPaid($StudentAmountPaid);
    		$NewFeeCollection->SetPaymentModeDetails($Clean['PaymentModeDetails']);
    
    // 		$NewFeeCollection->SetCreateUserID(1000001); // default admin
    		$NewFeeCollection->SetCreateUserID($LoggedInParent->GetUserID()); // parent
    
    		$NewFeeCollection->SetFeeCollectionDetails($Clean['FeeCollectionDetails']);		
    		
    // 		$NewFeeCollection->SetOtherChargesDetails($OtherChargesDetails);		
    // 		$NewFeeCollection->SetAdvanceFeeDetails($Clean['AdvanceFeeDetails']);		
    // 		$NewFeeCollection->SetParentID($Clean['ParentID']);		
    		$NewFeeCollection->SetDescription('Paid by parent`s app.');		
    
    		if (!$NewFeeCollection->Save())
    		{
    			$Response->SetError(1);
        		$Response->SetErrorCode(UNKNOWN_ERROR);
        		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	
        
        		echo json_encode($Response->GetResponseAsArray());
        		exit;
    		}
    		
    		$TransactionID = $NewFeeCollection->GetCurrentTransactionID();
        }   
	}
	else
	{
	    // code for refund payment if need farther in case of not submitting fees 
	    
// 	    $Response->SetError(1);
// 		$Response->SetErrorCode(UNKNOWN_ERROR);
// 		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

// 		echo json_encode($Response->GetResponseAsArray());
// 		exit;
	}
	
	if (!APIHelpers::UpdateTransactionStatus($TransactionID, $Clean['PaymentStatus'], $Clean['EasePayID'], $Clean['CentralFeeTransactionID'])) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}	

    $Response->SetMessage(ProcessAppMessages(SAVED_SUCCESSFULLY));
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>