<?php
//header('Content-Type: application/json');

require_once('../classes/class.users.php');
require_once('../classes/class.authentication.php');

try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	echo 'error|*****|Unknown error, please try again.';
	exit;
}
catch (Exception $e)
{
	echo 'error|*****|Unknown error, please try again.';
	exit;
}

require_once("../classes/class.date_processing.php");
require_once('../classes/school_administration/class.student_tc_details.php');

// require_once("../classes/school_administration/class.class_helpers.php");

$StudentID = 0;
$TCNumber = '';

$RegistrationNo = '';
$LastClassExamResult = '';
$PromotedToHigherClass = '';
$AnyFeeConcession = '';
$NoOfMeeting = '';

$PaidAllDues = '';
$TotalPresentDays = '';

$ResultStatus = '';
$NccCadet = '';
$GeneralConduct = '';
$LastDateOfSession = '';
$TcIssueDate = '';
$LeavingDate = '';
$StuckOffClass = '';
$ReasonOfLeaving = '';
$NoOfWorkingDays = '';
$OtherRemark = '';

if (isset($_POST['StudentID']))
{
	$StudentID = (int) $_POST['StudentID'];
}

if (isset($_POST['TCNumber']))
{
	$TCNumber = (string) $_POST['TCNumber'];
}

if (isset($_POST['RegistrationNo']))
{
	$RegistrationNo = (string) $_POST['RegistrationNo'];
}

if (isset($_POST['LastClassExamResult']))
{
	$LastClassExamResult = (string) $_POST['LastClassExamResult'];
}

if (isset($_POST['PromotedToHigherClass']))
{
	$PromotedToHigherClass = (string) $_POST['PromotedToHigherClass'];
}

if (isset($_POST['AnyFeeConcession']))
{
	$AnyFeeConcession = (string) $_POST['AnyFeeConcession'];
}

if (isset($_POST['NoOfMeeting']))
{
	$NoOfMeeting = (string) $_POST['NoOfMeeting'];
}

if (isset($_POST['PaidAllDues']))
{
	$PaidAllDues = (string) $_POST['PaidAllDues'];
}

if (isset($_POST['TotalPresentDays']))
{
	$TotalPresentDays = (string) $_POST['TotalPresentDays'];
}

if (isset($_POST['ResultStatus']))
{
	$ResultStatus = (string) $_POST['ResultStatus'];
}

if (isset($_POST['NccCadet']))
{
	$NccCadet = (string) $_POST['NccCadet'];
}

if (isset($_POST['GeneralConduct']))
{
	$GeneralConduct = (string) $_POST['GeneralConduct'];
}

if (isset($_POST['LastDateOfSession']))
{
	$LastDateOfSession = (string) $_POST['LastDateOfSession'];
}

if (isset($_POST['TcIssueDate']))
{
	$TcIssueDate = (string) $_POST['TcIssueDate'];
}

if (isset($_POST['LeavingDate']))
{
	$LeavingDate = (string) $_POST['LeavingDate'];
}

if (isset($_POST['StuckOffClass']))
{
	$StuckOffClass = (string) $_POST['StuckOffClass'];
}

if (isset($_POST['ReasonOfLeaving']))
{
	$ReasonOfLeaving = (string) $_POST['ReasonOfLeaving'];
}

if (isset($_POST['NoOfWorkingDays']))
{
	$NoOfWorkingDays = (string) $_POST['NoOfWorkingDays'];
}

if (isset($_POST['OtherRemark']))
{
	$OtherRemark = (string) $_POST['OtherRemark'];
}

if ($StudentID <= 0 || $TCNumber == '')
{
	echo 'error|*****|Unknown error, please try again.';
	exit;
}

$UpdatedTcDetails = array();
$TcDetailsToBeUpdate = array();

if ($LastDateOfSession != '') 
{
	$TcDetailsToBeUpdate[$StudentID]['LastDateOfSession'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($LastDateOfSession))));
}

$TcDetailsToBeUpdate[$StudentID]['RegistrationNo'] = $RegistrationNo;
$TcDetailsToBeUpdate[$StudentID]['LastClassExamResult'] = $LastClassExamResult;
$TcDetailsToBeUpdate[$StudentID]['PromotedToHigherClass'] = $PromotedToHigherClass;
$TcDetailsToBeUpdate[$StudentID]['AnyFeeConcession'] = $AnyFeeConcession;
$TcDetailsToBeUpdate[$StudentID]['NoOfMeeting'] = $NoOfMeeting;

$TcDetailsToBeUpdate[$StudentID]['PaidAllDues'] = $PaidAllDues;
$TcDetailsToBeUpdate[$StudentID]['TotalPresentDays'] = $TotalPresentDays;

$TcDetailsToBeUpdate[$StudentID]['TCNumber'] = $TCNumber;
$TcDetailsToBeUpdate[$StudentID]['ResultStatus'] = $ResultStatus;
$TcDetailsToBeUpdate[$StudentID]['NccCadet'] = $NccCadet;
$TcDetailsToBeUpdate[$StudentID]['GeneralConduct'] = $GeneralConduct;
$TcDetailsToBeUpdate[$StudentID]['LastDateOfSession'] = '';

if ($LastDateOfSession != '') 
{
	$TcDetailsToBeUpdate[$StudentID]['LastDateOfSession'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($LastDateOfSession))));
}

$TcDetailsToBeUpdate[$StudentID]['TcIssueDate'] = '';

if ($TcIssueDate != '') 
{
	$TcDetailsToBeUpdate[$StudentID]['TcIssueDate'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($TcIssueDate))));
}

$TcDetailsToBeUpdate[$StudentID]['LeavingDate'] = '';

if ($LeavingDate != '') 
{
	$TcDetailsToBeUpdate[$StudentID]['LeavingDate'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($LeavingDate))));
}

$TcDetailsToBeUpdate[$StudentID]['StuckOffClass'] = $StuckOffClass;
$TcDetailsToBeUpdate[$StudentID]['ReasonOfLeaving'] = $ReasonOfLeaving;
$TcDetailsToBeUpdate[$StudentID]['NoOfWorkingDays'] = $NoOfWorkingDays;
$TcDetailsToBeUpdate[$StudentID]['OtherRemark'] = $OtherRemark;
$TcDetailsToBeUpdate[$StudentID]['CreateUserID'] = $LoggedUser->GetUserID();

$UpdatedTcDetails = StudentTcDetail::UpdateStudentTcDetails($TcDetailsToBeUpdate);

if (count($UpdatedTcDetails) <= 0)
{
	echo 'error|*****|Error in execution query.';
	exit;
}

echo 'success|*****|';
// echo $UpdatedScheduleDetails[$TopicScheduleDetailID]['Status'];

// echo '|*****|';
// echo date('d/m/Y', strtotime($UpdatedScheduleDetails[$TopicScheduleDetailID]['EndDate']));

// echo '|*****|';
// echo $UpdatedScheduleDetails[$TopicScheduleDetailID]['Remark'];


exit;
?>